define(['exports', 'aurelia-templating', 'aurelia-pal', './list', './list-group', './list-item'], function (exports, _aureliaTemplating, _aureliaPal, _list, _listGroup, _listItem) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.ListItemSeparator = exports.ListItem2Lines = exports.ListItem = exports.ListGroupSubheader = exports.ListGroup = exports.ListDivider = exports.List = exports.Config = undefined;
    exports.configure = configure;

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var Config = exports.Config = function () {
        function Config() {
            _classCallCheck(this, Config);
        }

        Config.prototype.useContainerless = function useContainerless() {
            [_list.List, _list.ListDivider, _listGroup.ListGroup, _listGroup.ListGroupSubheader, _listItem.ListItem, _listItem.ListItem2Lines, _listItem.ListItemSeparator].forEach(function (classes) {
                return Object.keys(classes).forEach(function (key) {
                    return (0, _aureliaTemplating.containerless)(classes[key]);
                });
            });
        };

        Config.prototype.configure = function configure(config) {
            config.globalResources(_aureliaPal.PLATFORM.moduleName('./list'));
            config.globalResources(_aureliaPal.PLATFORM.moduleName('./list-group'));
            config.globalResources(_aureliaPal.PLATFORM.moduleName('./list-item'));
        };

        return Config;
    }();

    function configure(aurelia) {
        var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

        var config = aurelia.container.get(Config);

        if (typeof callback === 'function') {
            callback(config);
        }

        config.configure(aurelia);
    }

    exports.List = _list.List;
    exports.ListDivider = _list.ListDivider;
    exports.ListGroup = _listGroup.ListGroup;
    exports.ListGroupSubheader = _listGroup.ListGroupSubheader;
    exports.ListItem = _listItem.ListItem;
    exports.ListItem2Lines = _listItem.ListItem2Lines;
    exports.ListItemSeparator = _listItem.ListItemSeparator;
});