define(['exports', '@aurelia-material-components/core', 'aurelia-templating', './list'], function (exports, _index, _aureliaTemplating, _list) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.ListItem2Lines = exports.ListItemSeparator = exports.ListItem = undefined;

    function _initDefineProp(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
            enumerable: descriptor.enumerable,
            configurable: descriptor.configurable,
            writable: descriptor.writable,
            value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
    }

    function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object['ke' + 'ys'](descriptor).forEach(function (key) {
            desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
            desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
            return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
            desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
            desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
            Object['define' + 'Property'](target, property, desc);
            desc = null;
        }

        return desc;
    }

    function _initializerWarningHelper(descriptor, context) {
        throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var _dec, _dec2, _class, _dec3, _dec4, _class2, _dec5, _dec6, _class3, _desc, _value, _class4, _descriptor, _descriptor2;

    var listItem = '<template>\n    ' + _list.requireCss + '\n    <li class.bind="classSet" data-mdc-id.bind="dataMDCId">\n        <slot></slot>\n    </li>\n</template>';

    var ListItem = exports.ListItem = (_dec = (0, _aureliaTemplating.customElement)('mdc-list-item'), _dec2 = (0, _aureliaTemplating.inlineView)(listItem), _dec(_class = _dec2(_class = function (_CustomElement) {
        _inherits(ListItem, _CustomElement);

        function ListItem() {
            _classCallCheck(this, ListItem);

            return _possibleConstructorReturn(this, _CustomElement.apply(this, arguments));
        }

        _createClass(ListItem, [{
            key: 'classSet',
            get: function get() {
                return this.prepareClasses({ 'mdc-list-item': true });
            }
        }]);

        return ListItem;
    }(_index.CustomElement)) || _class) || _class);


    var listItemSeparator = '<template>\n    ' + _list.requireCss + '\n    <li class.bind="classSet" role="separator" data-mdc-id.bind="dataMDCId"></li>\n</template>';

    var ListItemSeparator = exports.ListItemSeparator = (_dec3 = (0, _aureliaTemplating.customElement)('mdc-list-item-separator'), _dec4 = (0, _aureliaTemplating.inlineView)(listItemSeparator), _dec3(_class2 = _dec4(_class2 = function (_ListItem) {
        _inherits(ListItemSeparator, _ListItem);

        function ListItemSeparator() {
            _classCallCheck(this, ListItemSeparator);

            return _possibleConstructorReturn(this, _ListItem.apply(this, arguments));
        }

        _createClass(ListItemSeparator, [{
            key: 'classSet',
            get: function get() {
                return this.prepareClasses({ 'mdc-list-divider': true });
            }
        }]);

        return ListItemSeparator;
    }(ListItem)) || _class2) || _class2);


    var listItem2Lines = '<template>\n    ' + _list.requireCss + '\n    <li class.bind="classSet" data-mdc-id.bind="dataMDCId">\n        <span class.bind="classSetLineOne">\n            <slot id="lineOne"></slot>\n            <span class.bind="classSetLineTwo">\n                <slot id="lineTwo"></slot>\n            </span>\n        </span>\n    </li>\n</template>';

    var ListItem2Lines = exports.ListItem2Lines = (_dec5 = (0, _aureliaTemplating.customElement)('mdc-list-item-two-lines'), _dec6 = (0, _aureliaTemplating.inlineView)(listItem2Lines), _dec5(_class3 = _dec6(_class3 = (_class4 = function (_ListItem2) {
        _inherits(ListItem2Lines, _ListItem2);

        function ListItem2Lines() {
            var _temp, _this3, _ret;

            _classCallCheck(this, ListItem2Lines);

            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            return _ret = (_temp = (_this3 = _possibleConstructorReturn(this, _ListItem2.call.apply(_ListItem2, [this].concat(args))), _this3), _initDefineProp(_this3, 'stylesLineOne', _descriptor, _this3), _initDefineProp(_this3, 'stylesLineTwo', _descriptor2, _this3), _temp), _possibleConstructorReturn(_this3, _ret);
        }

        _createClass(ListItem2Lines, [{
            key: 'classSetLineOne',
            get: function get() {
                return this.prepareClasses({ 'mdc-list-item__text': true }, 'LineOne');
            }
        }, {
            key: 'classSetLineTwo',
            get: function get() {
                return this.prepareClasses({ 'mdc-list-item__secondary-text': true }, 'LineTwo');
            }
        }]);

        return ListItem2Lines;
    }(ListItem), (_descriptor = _applyDecoratedDescriptor(_class4.prototype, 'stylesLineOne', [_aureliaTemplating.bindable], {
        enumerable: true,
        initializer: function initializer() {
            return '';
        }
    }), _descriptor2 = _applyDecoratedDescriptor(_class4.prototype, 'stylesLineTwo', [_aureliaTemplating.bindable], {
        enumerable: true,
        initializer: function initializer() {
            return '';
        }
    })), _class4)) || _class3) || _class3);
});