function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

import { containerless } from 'aurelia-templating';
import { PLATFORM } from 'aurelia-pal';

import { List, ListDivider } from './list';
import { ListGroup, ListGroupSubheader } from './list-group';
import { ListItem, ListItem2Lines, ListItemSeparator } from './list-item';

export var Config = function () {
    function Config() {
        _classCallCheck(this, Config);
    }

    Config.prototype.useContainerless = function useContainerless() {
        [List, ListDivider, ListGroup, ListGroupSubheader, ListItem, ListItem2Lines, ListItemSeparator].forEach(function (classes) {
            return Object.keys(classes).forEach(function (key) {
                return containerless(classes[key]);
            });
        });
    };

    Config.prototype.configure = function configure(config) {
        config.globalResources(PLATFORM.moduleName('./list'));
        config.globalResources(PLATFORM.moduleName('./list-group'));
        config.globalResources(PLATFORM.moduleName('./list-item'));
    };

    return Config;
}();

export function configure(aurelia) {
    var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

    var config = aurelia.container.get(Config);

    if (typeof callback === 'function') {
        callback(config);
    }

    config.configure(aurelia);
}

export { List, ListDivider, ListGroup, ListGroupSubheader, ListItem, ListItem2Lines, ListItemSeparator };