'use strict';

System.register(['aurelia-templating', 'aurelia-pal', './list', './list-group', './list-item'], function (_export, _context) {
    "use strict";

    var containerless, PLATFORM, List, ListDivider, ListGroup, ListGroupSubheader, ListItem, ListItem2Lines, ListItemSeparator, Config;

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function configure(aurelia) {
        var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

        var config = aurelia.container.get(Config);

        if (typeof callback === 'function') {
            callback(config);
        }

        config.configure(aurelia);
    }

    _export('configure', configure);

    return {
        setters: [function (_aureliaTemplating) {
            containerless = _aureliaTemplating.containerless;
        }, function (_aureliaPal) {
            PLATFORM = _aureliaPal.PLATFORM;
        }, function (_list) {
            List = _list.List;
            ListDivider = _list.ListDivider;
        }, function (_listGroup) {
            ListGroup = _listGroup.ListGroup;
            ListGroupSubheader = _listGroup.ListGroupSubheader;
        }, function (_listItem) {
            ListItem = _listItem.ListItem;
            ListItem2Lines = _listItem.ListItem2Lines;
            ListItemSeparator = _listItem.ListItemSeparator;
        }],
        execute: function () {
            _export('Config', Config = function () {
                function Config() {
                    _classCallCheck(this, Config);
                }

                Config.prototype.useContainerless = function useContainerless() {
                    [List, ListDivider, ListGroup, ListGroupSubheader, ListItem, ListItem2Lines, ListItemSeparator].forEach(function (classes) {
                        return Object.keys(classes).forEach(function (key) {
                            return containerless(classes[key]);
                        });
                    });
                };

                Config.prototype.configure = function configure(config) {
                    config.globalResources(PLATFORM.moduleName('./list'));
                    config.globalResources(PLATFORM.moduleName('./list-group'));
                    config.globalResources(PLATFORM.moduleName('./list-item'));
                };

                return Config;
            }());

            _export('Config', Config);

            _export('List', List);

            _export('ListDivider', ListDivider);

            _export('ListGroup', ListGroup);

            _export('ListGroupSubheader', ListGroupSubheader);

            _export('ListItem', ListItem);

            _export('ListItem2Lines', ListItem2Lines);

            _export('ListItemSeparator', ListItemSeparator);
        }
    };
});